package com.hjsoft.integration.zhjw;

package ..deTemp.1729408215959;

import cn.avicnet.apigw.client.sdk.SignatureAuth;
import cn.avicnet.apigw.client.sdk.SignatureAuthConfig;
import cn.avicnet.apigw.client.sdk.SignatureAuthFactory;
import cn.avicnet.apigw.client.sdk.constant.ApiGwEnum;
import com.alibaba.csb.sdk.HttpCaller;
import com.alibaba.csb.sdk.HttpCallerException;
import com.alibaba.csb.sdk.HttpParameters;
import com.alibaba.csb.sdk.HttpReturn;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.hjsoft.base.staff.BasicMongoDBService;
import com.hjsoft.base.structure.RpcStructureService;
import com.hjsoft.base.structure.StructurePOJO;
import com.hjsoft.frame.log.RpcLogService;
import com.hjsoft.frame.parameter.RpcParameterService;
import com.hjsoft.frame.user.RpcUserService;
import com.hjsoft.frame.user.UserEntity;
import com.hjsoft.frame.user.UserService;
import com.hjsoft.integration.IntegrationAdaptable;
import com.hjsoft.integration.IntegrationCustomEntity;
import com.hjsoft.integration.IntegrationCustomService;
import com.hjsoft.integration.IntegrationEntity;
import com.hjsoft.integration.acceptdataInfo.RecordDataEntity;
import com.hjsoft.integration.acceptdataInfo.RecordDataService;
import com.hjsoft.integration.acceptdataInfo.RecordDetailEntity;
import com.hjsoft.integration.acceptdataInfo.RecordDetailService;
import com.hjsoft.integration.hcm.service.HcmService;
import com.hjsoft.integration.hcm.support.HcmTheme;
import com.hjsoft.integration.record.business.pojo.RecordBusinessEntity;
import com.hjsoft.integration.runtime.RunParamEntity;
import com.hjsoft.integration.runtime.RunParamEntityService;
import com.hjsoft.integration.suffix.IntegrationSuffixEntity;
import com.hjsoft.integration.suffix.IntegrationSuffixService;
import com.hjsoft.integration.zhjw.support.ApiSixAccountResponse;
import com.hjsoft.integration.zhjw.support.AuthenticationFailure;
import com.hjsoft.integration.zhjw.support.AuthenticationSuccess;
import com.hjsoft.integration.zhjw.support.CsbAccountResponse;
import com.hjsoft.integration.zhjw.support.IDaasAccountLoadResult;
import com.hjsoft.integration.zhjw.support.IDaasValidTicketResponse;
import com.hjsoft.integration.zhjw.support.SyncStastics;
import com.hjsoft.tenant.TenantEntity;
import com.hjsoft.tenant.taskormessage.UserTaskEntity;
import com.mongodb.BasicDBObject;
import com.rap.common.entity.AutoIdEntity;
import com.rap.common.exception.BaseException;
import com.rap.common.exception.BusinessException;
import com.rap.common.exception.SystemException;
import com.rap.common.net.NetBrowser;
import com.rap.common.utils.BatchUtils;
import com.rap.common.utils.CollectionHelper;
import com.rap.common.utils.Jsons;
import com.rap.common.utils.Strings;
import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import java.util.stream.Collectors;
import javax.annotation.PostConstruct;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.conn.HttpHostConnectException;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.connection.RedisConnectionFactory;
import org.springframework.data.redis.connection.jedis.JedisConnectionFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.data.redis.serializer.RedisSerializer;
import org.springframework.data.redis.serializer.StringRedisSerializer;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

@Service
public class ZhjwService implements IntegrationAdaptable {
  Logger logger = LoggerFactory.getLogger(com.hjsoft.integration.zhjw.ZhjwService.class);
  
  @Autowired
  private RpcUserService rpcUserService;
  
  @Autowired
  private RpcLogService logService;
  
  @Autowired
  private UserService userService;
  
  @Autowired
  private IntegrationCustomService integrationCustomService;
  
  @Autowired
  private IntegrationSuffixService integrationSuffixService;
  
  @Autowired
  private RpcParameterService rpcParameterService;
  
  @Autowired
  private RecordDataService recordDataService;
  
  @Autowired
  private RecordDetailService recordDetailService;
  
  @Autowired
  private RunParamEntityService runParamEntityService;
  
  @Autowired
  private HcmService hcmService;
  
  @Autowired
  private RpcStructureService structureService;
  
  @Autowired
  private BasicMongoDBService basicMongoDBService;
  
  @Autowired
  private JedisConnectionFactory redisFactory;
  
  private RedisTemplate<String, String> tokenCache;
  
  private Map<String, Integer> zhsl_hjsl = new HashMap<>();
  
  private Map<Integer, String> hjsl_name = new HashMap<>();
  
  @PostConstruct
  private void init() {
    this.zhsl_hjsl.put("1", Integer.valueOf(4));
    this.zhsl_hjsl.put("2", Integer.valueOf(3));
    this.zhsl_hjsl.put("3", Integer.valueOf(2));
    this.zhsl_hjsl.put("4", Integer.valueOf(1));
    this.hjsl_name.put(Integer.valueOf(4), "非密");
    this.hjsl_name.put(Integer.valueOf(3), "一般");
    this.hjsl_name.put(Integer.valueOf(2), "重要");
    this.hjsl_name.put(Integer.valueOf(1), "核心");
    this.tokenCache = new RedisTemplate();
    this.tokenCache.setConnectionFactory((RedisConnectionFactory)this.redisFactory);
    this.tokenCache.setKeySerializer((RedisSerializer)new StringRedisSerializer());
    this.tokenCache.setValueSerializer((RedisSerializer)new StringRedisSerializer());
    this.tokenCache.afterPropertiesSet();
  }
  
  public String getAppKey() {
    return "zhjw";
  }
  
  public void cache(String key, Object value) {
    this.tokenCache.opsForValue().set(key, Jsons.jsonString(value));
  }
  
  public <R> R getFromCache(String key, Class<R> objType) {
    String v = (String)this.tokenCache.opsForValue().get(key);
    if (StringUtils.isBlank(v))
      return null; 
    return (R)Jsons.objcet(v, objType);
  }
  
  public String getSysParamValue(String key) {
    return this.rpcParameterService.getParam(key);
  }
  
  public AuthenticationSuccess getUserInfo(Map<String, String> configs, String ticket, String redirectUrl) {
    String apiUrl = configs.get("apiUrl");
    String idaasAppId = configs.get("appId");
    String idaasAccessKey = configs.get("accessKey");
    String idaasSecretKey = configs.get("secretKey");
    String selfDomain = getSysParamValue("domain");
    selfDomain = selfDomain.startsWith("https://") ? selfDomain.replace("https://", "") : selfDomain.replace("http://", "");
    IDaasValidTicketResponse ir = null;
    String evn = getSysParamValue("zhjw.evn.key");
    if ("jh".equals(evn)) {
      ir = getUserInfoFromTicketByApiSix(apiUrl, idaasAppId, idaasAccessKey, idaasSecretKey, ticket, redirectUrl, selfDomain);
    } else {
      ir = getUserInfoFromTicketByCSB(apiUrl, idaasAccessKey, idaasSecretKey, ticket, redirectUrl, selfDomain);
    } 
    AuthenticationSuccess userInfo = ir.getUserInfo();
    if (userInfo == null) {
      AuthenticationFailure af = ir.getFailInfo();
      throw new BusinessException(null, Strings.join(new Object[] { "验证ticket失败：", af.getDescription(), "(", af.getCode(), ")" }));
    } 
    return userInfo;
  }
  
  public void autoSyncAccounts() {
    List<IntegrationCustomEntity> zhjwIntegrations = getZhjwIntegrationApps();
    if (zhjwIntegrations.isEmpty())
      return; 
    RecordBusinessEntity rbe = new RecordBusinessEntity();
    rbe.setBusinessId(getAppKey());
    for (IntegrationCustomEntity ic : zhjwIntegrations) {
      if (ic.isSyncing()) {
        this.logger.warn("ZHJW IntegrationCustom#{} account is syncing !", ic.getUuid());
        continue;
      } 
      Map<String, String> configs = ic.getConfObj();
      if (configs == null || configs.isEmpty()) {
        this.logger.warn("ZHJW IntegrationCustom#{} does not config integration params, will not push logs !", ic.getUuid());
        continue;
      } 
      String hcmSystemCode = configs.get("hcmSystemCode");
      if (StringUtils.isBlank(hcmSystemCode)) {
        this.logger.warn("ZHJW IntegrationCustom#{} has not config [systemCode], will not push logs !", ic.getUuid());
        continue;
      } 
      String hcmAuthCode = configs.get("hcmAuthCode");
      if (StringUtils.isBlank(hcmAuthCode)) {
        this.logger.warn("ZHJW IntegrationCustom#{} has not config [authCode], will not push logs !", ic.getUuid());
        continue;
      } 
      String hcmUrl = configs.get("hcmUrl");
      if (StringUtils.isBlank(hcmUrl)) {
        this.logger.warn("ZHJW IntegrationCustom#{} has not config [hcmUrl], will not push logs !", ic.getUuid());
        continue;
      } 
      syncZhUsersToHjy(ic, null, 0);
    } 
  }
  
  public void autoPushLogsToHcm() {
    List<IntegrationCustomEntity> zhjwIntegrations = getZhjwIntegrationApps();
    if (zhjwIntegrations.isEmpty())
      return; 
    for (IntegrationCustomEntity ic : zhjwIntegrations) {
      Map<String, String> configs = ic.getConfObj();
      if (configs == null || configs.isEmpty()) {
        this.logger.warn("ZHJW push logs failed: IntegrationCustom#{} does not config integration params !", ic.getUuid());
        continue;
      } 
      String hcmDomain = configs.get("hcmUrl");
      if (StringUtils.isBlank(hcmDomain)) {
        this.logger.warn("ZHJW push logs failed: IntegrationCustom#{} no hcm domain setted !", ic.getUuid());
        continue;
      } 
      String systemCode = configs.get("hcmSystemCode");
      if (StringUtils.isBlank(systemCode)) {
        this.logger.warn("ZHJW push logs failed: IntegrationCustom#{} no hcm systemCode setted !", ic.getUuid());
        continue;
      } 
      String authCode = configs.get("hcmAuthCode");
      if (StringUtils.isBlank(authCode)) {
        this.logger.warn("ZHJW push logs failed: IntegrationCustom#{} no hcm authCode setted !", ic.getUuid());
        continue;
      } 
      this.hcmService.pushSysLogsToHcm(ic.getTenantId(), hcmDomain, false, systemCode, authCode);
    } 
  }
  
  private List<IntegrationCustomEntity> getZhjwIntegrationApps() {
    List<IntegrationCustomEntity> zhjwIntegrations = this.integrationCustomService.findEnableByAppKey(getAppKey());
    return zhjwIntegrations;
  }
  
  @Async
  public void syncZhUsersToHjy(IntegrationCustomEntity ic, String startTime, int way) {
    Date startDate = new Date();
    RecordDataEntity recordDataStr = new RecordDataEntity(ic.getTenantId(), RecordDataEntity.DIRECTION_FROMIDAAS, RecordDataEntity.TYPE_STSFF, (way == 0) ? RecordDataEntity.TIGGER_MODE_AUTOMATIC : RecordDataEntity.TIGGER_MODE__MANUAL, RecordDataEntity.STATE_SYNCHRONIZING, startDate);
    String evn = getSysParamValue("zhjw.evn.key");
    boolean isJhw = "jh".equals(evn);
    if (isJhw)
      this.recordDataService.save(recordDataStr); 
    Map<String, RecordDataEntity> recordDataEntityMap = new HashMap<>();
    String tenantIdMain = getSysParamValue("tenantIdMain");
    String startTimeKey = isJhw ? "zhjw.jh.syncStart" : "zhjw.sw.syncStart";
    RunParamEntity startTimeParam = null;
    String nextStartTime = null;
    String msg = "同步完成";
    List<RecordDetailEntity> rds = new ArrayList<>();
    Map<String, List<RecordDetailEntity>> resMap = new HashMap<>();
    this.integrationCustomService.updateSyncStart(ic.getUuid(), 3, new Date(), Strings.join(new Object[] { "正在同步账号(", (way == 1) ? "手动" : "自动", ") ..." }));
    this.logger.info("ZHJW IntegrationCustom#{} start auto sync accounts(increasement start time:{}), !", ic.getUuid(), startTime);
    try {
      recordDataStr.setFlag(Boolean.valueOf(false));
      recordDataStr.setState(RecordDataEntity.STATE_COMPLETED);
      if (ic.isSyncing()) {
        msg = "有正在执行的同步任务，当前操作不执行";
        return;
      } 
      String tenantId = ic.getTenantId();
      Map<String, String> configs = ic.getConfObj();
      if (way == 0) {
        startTimeParam = this.runParamEntityService.getByTenantIdAndPcode(ic.getTenantId(), startTimeKey);
        if (startTimeParam == null) {
          msg = "未进行初始化同步，自动不在执行";
          return;
        } 
        startTime = startTimeParam.getPvalue();
      } else if (StringUtils.isBlank(startTime)) {
        startTime = "0";
      } 
      nextStartTime = startTime;
      if (isJhw) {
        nextStartTime = loadZhUsersByApiSix(configs, tenantId, startTime, rds);
      } else {
        String tenantIdStr = configs.get("tenantIds");
        String[] tenantIds = tenantIdStr.split(";");
        String suffix = "";
        Integer maxSuffix = this.integrationSuffixService.getMaxSuffix();
        if (maxSuffix == null)
          maxSuffix = Integer.valueOf(0); 
        List<IntegrationSuffixEntity> suffixEntities = this.integrationSuffixService.getAllByTenantIdAndApp("zhjw");
        Map<String, IntegrationSuffixEntity> suffixEntityMap = CollectionHelper.mapDict(suffixEntities, suf -> suf.getTenantId());
        byte b;
        int i;
        String[] arrayOfString1;
        for (i = (arrayOfString1 = tenantIds).length, b = 0; b < i; ) {
          String str = arrayOfString1[b];
          RecordDataEntity recordDataStrSw = new RecordDataEntity(str, RecordDataEntity.DIRECTION_FROMIDAAS, RecordDataEntity.TYPE_STSFF, (way == 0) ? RecordDataEntity.TIGGER_MODE_AUTOMATIC : RecordDataEntity.TIGGER_MODE__MANUAL, RecordDataEntity.STATE_SYNCHRONIZING, startDate);
          this.recordDataService.save(recordDataStrSw);
          recordDataStrSw.setFlag(Boolean.valueOf(false));
          recordDataStrSw.setState(RecordDataEntity.STATE_COMPLETED);
          recordDataEntityMap.put(str, recordDataStrSw);
          if (tenantIdMain.equals(str)) {
            suffix = "";
          } else if (suffixEntityMap.get(str) != null) {
            suffix = String.valueOf(((IntegrationSuffixEntity)suffixEntityMap.get(str)).getSuffix());
          } else {
            IntegrationSuffixEntity integrationSuffixEntity = new IntegrationSuffixEntity(Integer.valueOf(maxSuffix.intValue() + 1), "zhjw", str, new Date(), ic.getCreator());
            this.integrationSuffixService.save((AutoIdEntity)integrationSuffixEntity);
            suffix = String.valueOf(maxSuffix.intValue() + 1);
            maxSuffix = Integer.valueOf(maxSuffix.intValue() + 1);
          } 
          List<RecordDetailEntity> rdsSw = new ArrayList<>();
          nextStartTime = loadZhUsersByCsb(configs, str, startTime, rdsSw, suffix);
          resMap.put(str, rdsSw);
          recordDataStrSw.setFlag(Boolean.valueOf(true));
          b++;
        } 
      } 
      recordDataStr.setFlag(Boolean.valueOf(true));
    } catch (SystemException|BusinessException e) {
      msg = "同步中断：" + e.getMessage();
    } catch (Exception e) {
      msg = "同步中断：出现未知异常";
      this.logger.error("startSyncZhUsersToHjy exception:", e);
    } finally {
      ic = (IntegrationCustomEntity)this.integrationCustomService.getById(ic.getUuid());
      ic.setSyncState(Integer.valueOf(0));
      ic.setLastSyncTime(new Date());
      ic.setSyncDesc(msg);
      this.integrationCustomService.saveOnly((AutoIdEntity)ic);
      if (isJhw) {
        recordDataStr.setEndDate(new Date());
        recordDataStr.setErrmsg(msg);
        this.recordDataService.save(recordDataStr);
        this.logger.info("Sync accounts[{}] startTime[{}] nextStartTime[{}] success[{}]", new Object[] { evn, startTime, nextStartTime, recordDataStr.getFlag() });
        if (recordDataStr.getFlag().booleanValue() && StringUtils.isNotBlank(nextStartTime) && !nextStartTime.equals(startTime)) {
          if (startTimeParam == null)
            startTimeParam = this.runParamEntityService.getByTenantIdAndPcode(ic.getTenantId(), startTimeKey); 
          if (startTimeParam == null) {
            startTimeParam = new RunParamEntity();
            startTimeParam.setPcode(startTimeKey);
            startTimeParam.setTenantId(ic.getTenantId());
            startTimeParam.setPdesc("记录下次从IDaas拉取账号的起始时间点。此参数为程序运行时动态生成，一般不需要手动修改");
          } 
          startTimeParam.setPvalue(nextStartTime);
          this.runParamEntityService.saveOnly((AutoIdEntity)startTimeParam);
        } 
        if (!rds.isEmpty()) {
          for (RecordDetailEntity rd : rds) {
            rd.setTotalId(recordDataStr.getUuid());
            rd.setTenantId(recordDataStr.getTenantId());
            rd.setCreateDate(startDate);
          } 
          this.recordDetailService.save(rds);
        } 
      } else {
        Iterator<Map.Entry<String, RecordDataEntity>> iterator = recordDataEntityMap.entrySet().iterator();
        while (iterator.hasNext()) {
          Map.Entry<String, RecordDataEntity> entry = iterator.next();
          String key = entry.getKey();
          RecordDataEntity recordDataEntity = entry.getValue();
          recordDataEntity.setEndDate(new Date());
          recordDataEntity.setErrmsg(msg);
          this.recordDataService.save(recordDataEntity);
          this.logger.info("Sync accounts[{}] startTime[{}] nextStartTime[{}] success[{}]", new Object[] { evn, startTime, nextStartTime, recordDataEntity.getFlag() });
          if (recordDataEntity.getFlag().booleanValue() && StringUtils.isNotBlank(nextStartTime) && !nextStartTime.equals(startTime)) {
            if (startTimeParam == null)
              startTimeParam = this.runParamEntityService.getByTenantIdAndPcode(ic.getTenantId(), startTimeKey); 
            if (startTimeParam == null) {
              startTimeParam = new RunParamEntity();
              startTimeParam.setPcode(startTimeKey);
              startTimeParam.setTenantId(ic.getTenantId());
              startTimeParam.setPdesc("记录下次从IDaas拉取账号的起始时间点。此参数为程序运行时动态生成，一般不需要手动修改");
            } 
            startTimeParam.setPvalue(nextStartTime);
            this.runParamEntityService.saveOnly((AutoIdEntity)startTimeParam);
            List<RecordDetailEntity> rdsSw = resMap.get(key);
            if (!rdsSw.isEmpty()) {
              for (RecordDetailEntity rd : rdsSw) {
                rd.setTotalId(recordDataEntity.getUuid());
                rd.setTenantId(recordDataEntity.getTenantId());
                rd.setCreateDate(startDate);
              } 
              this.recordDetailService.save(rdsSw);
            } 
          } 
        } 
      } 
    } 
  }
  
  private String loadZhUsersByCsb(Map<String, String> configs, String tenantId, String startTime, List<RecordDetailEntity> rds, String suffix) {
    String apiUrl = configs.get("apiUrl");
    String idaasAccessKey = configs.get("accessKey");
    String idaasSecretKey = configs.get("secretKey");
    String appKey = configs.get("appKey");
    HttpParameters.Builder builder = HttpParameters.newBuilder();
    builder.requestURL(apiUrl).api("getUsers")
      .version("1.0.0").method("get").contentType("application/x-www-form-urlencoded;charset=utf-8")
      .accessKey(idaasAccessKey).secretKey(idaasSecretKey);
    builder.putHeaderParamsMap("appKey", appKey);
    builder.putParamsMap("includeStartTime", new String[] { "true" });
    HttpParameters.Builder builderStr = HttpParameters.newBuilder();
    builderStr.requestURL(apiUrl).api("getOrgs")
      .version("1.0.0").method("get").contentType("application/x-www-form-urlencoded;charset=utf-8")
      .accessKey(idaasAccessKey).secretKey(idaasSecretKey);
    builderStr.putHeaderParamsMap("appKey", appKey);
    builderStr.putParamsMap("includeStartTime", new String[] { "true" });
    int pageNum = 0;
    int strpageNum = 0;
    Long nextStartTime = null;
    Map<String, UserEntity> zhId_hjuser = new HashMap<>();
    SyncStastics stc = new SyncStastics();
    String strNextStartTime = "0";
    List<Map<String, Object>> zhOrgAlls = new ArrayList<>();
    while (true) {
      builderStr.putParamsMap("startTime", new String[] { strNextStartTime });
      builderStr.putParamsMap("pageNum", new String[] { String.valueOf(strpageNum) });
      try {
        HttpReturn res = HttpCaller.invokeReturn(builderStr.build());
        this.logger.info("Loaded str org data from csb : {}", res.getResponseStr());
        CsbAccountResponse lar = (CsbAccountResponse)Jsons.objcet(res.getResponseStr(), CsbAccountResponse.class);
        if (!lar.success()) {
          this.logger.info("Loaded str from csb : {}", res.getResponseStr());
          throw new BusinessException(null, Strings.join(new Object[] { "获取中航金网账号信息失败: ", lar.getResultMsg(), "(", lar.getResultCode(), ")" }));
        } 
        this.logger.info("Loaded str(removed PHOTO) from csb : {}", lar);
        List<Map<String, Object>> csbStrs = lar.getData();
        if (csbStrs == null)
          break; 
        zhOrgAlls.addAll(csbStrs);
        nextStartTime = (Long)CollectionHelper.minValue(csbStrs, u -> (Long)u.get("LAST_SYN_TIME"));
        strNextStartTime = String.valueOf(nextStartTime);
        if (!lar.getHasNextPage())
          break; 
        strpageNum++;
      } catch (HttpCallerException e) {
        if (e.getCause() instanceof java.net.UnknownHostException || e.getCause() instanceof org.apache.http.conn.ConnectTimeoutException) {
          this.logger.error(Strings.join(new Object[] { "Csb str interface[", apiUrl, "] not accessable : " }, ), (Throwable)e);
          throw new BusinessException(null, "获取组织信息CSB接口不可访问");
        } 
        throw new RuntimeException(Strings.join(new Object[] { "Load zhjw accounts failed: " }, ), e);
      } 
    } 
    cache("zhOrgAlls", zhOrgAlls);
    List<Map<String, Object>> zhOrgStrAlls = new ArrayList<>();
    for (int i = 0; i < zhOrgAlls.size(); i++) {
      Map<String, Object> zhorg = zhOrgAlls.get(i);
      if (zhorg.get("TYPE").toString().equals("1"))
        zhOrgStrAlls.add(zhorg); 
    } 
    cache("zhOrgStrAlls", zhOrgStrAlls);
    Map<String, Map<String, Object>> orgEnterpriseNoMap = CollectionHelper.mapDict(zhOrgStrAlls, zho -> zho.get("COMPANY_ID").toString());
    this.logger.info("apiSix str org {}", orgEnterpriseNoMap);
    List<BasicDBObject> baseObjects = this.basicMongoDBService.findFastByTenantIdAndSubCode(tenantId, "B01");
    Map<String, BasicDBObject> basicDBObjectMap = CollectionHelper.mapDict(baseObjects, base -> base.getString("B01U1"));
    List<StructurePOJO> structurePOJOS = this.structureService.findAllStructure(tenantId);
    Map<String, StructurePOJO> uuidstructurePOJOMap = CollectionHelper.mapDict(structurePOJOS, str -> str.getOrgId());
    while (true) {
      builder.putParamsMap("startTime", new String[] { startTime });
      builder.putParamsMap("pageNum", new String[] { String.valueOf(pageNum) });
      try {
        HttpReturn res = HttpCaller.invokeReturn(builder.build());
        this.logger.info("Loaded accounts org data from csb : {}", res.getResponseStr());
        CsbAccountResponse lar = (CsbAccountResponse)Jsons.objcet(res.getResponseStr(), CsbAccountResponse.class);
        if (!lar.success()) {
          this.logger.info("Loaded accounts from csb : {}", res.getResponseStr());
          throw new BusinessException(null, Strings.join(new Object[] { "获取中航金网账号信息失败: ", lar.getResultMsg(), "(", lar.getResultCode(), ")" }));
        } 
        this.logger.info("Loaded accounts(removed PHOTO) from csb : {}", lar);
        List<Map<String, Object>> csbUsers = lar.getData();
        if (csbUsers != null)
          for (Map<String, Object> zu : csbUsers) {
            zu.remove("PHOTO");
            this.logger.info("Loaded csb user: {}", zu);
          }  
        List<Map<String, Object>> zhUsers = csbToZhUsers(csbUsers);
        saveOrUpdateUsers(tenantId, zhUsers, zhId_hjuser, stc, rds, suffix, orgEnterpriseNoMap, basicDBObjectMap, uuidstructurePOJOMap, false);
        nextStartTime = (Long)CollectionHelper.minValue(csbUsers, u -> (Long)u.get("LAST_SYN_TIME"));
        startTime = String.valueOf(nextStartTime);
        if (!lar.getHasNextPage())
          break; 
        pageNum++;
      } catch (HttpCallerException e) {
        if (e.getCause() instanceof java.net.UnknownHostException || e.getCause() instanceof org.apache.http.conn.ConnectTimeoutException) {
          this.logger.error(Strings.join(new Object[] { "Csb interface[", apiUrl, "] not accessable : " }, ), (Throwable)e);
          throw new BusinessException(null, "获取账号信息CSB接口不可访问");
        } 
        throw new RuntimeException(Strings.join(new Object[] { "Load zhjw accounts failed: " }, ), e);
      } 
    } 
    this.logger.info("Sync zhjw csb accounts report: {}", stc);
    return String.valueOf(nextStartTime);
  }
  
  private String loadZhUsersByApiSix(Map<String, String> configs, String tenantId, String startTime, List<RecordDetailEntity> rds) {
    String apiUrl = configs.get("apiUrl");
    String idaasAccessKey = configs.get("accessKey");
    String idaasSecretKey = configs.get("secretKey");
    String appKey = configs.get("appKey");
    String selfDomain = getSysParamValue("domain");
    selfDomain = selfDomain.startsWith("https://") ? selfDomain.replace("https://", "") : selfDomain.replace("http://", "");
    Map<String, String> headerMap = new HashMap<>();
    headerMap.put("X-Hostname", selfDomain);
    headerMap.put("appKey", appKey);
    String url = String.valueOf(apiUrl) + "idaas/resource/sync/users";
    String strUrl = String.valueOf(apiUrl) + "idaas/resource/sync/orgs";
    SignatureAuthConfig apisixAuthConfig = new SignatureAuthConfig();
    apisixAuthConfig.setApiGw(ApiGwEnum.APACHE_APISIX);
    apisixAuthConfig.setAccessKey(idaasAccessKey);
    apisixAuthConfig.setSecretKey(idaasSecretKey);
    SignatureAuth signatureAuth = SignatureAuthFactory.createSignatureAuth(apisixAuthConfig);
    Integer pageNum = Integer.valueOf(1);
    Integer strpageNum = Integer.valueOf(1);
    String nextStartTime = startTime;
    Map<String, UserEntity> zhId_hjuser = new HashMap<>();
    SyncStastics stc = new SyncStastics();
    String strNextStartTime = "0";
    List<Map<String, Object>> zhOrgAlls = new ArrayList<>();
    try {
      while (true) {
        URI uri = (new URIBuilder(strUrl)).addParameter("startTime", strNextStartTime).addParameter("includeStartTime", "true").addParameter("pageNum", String.valueOf(strpageNum)).build();
        HttpUriRequest httpUriRequest = signatureAuth.createHttpUriRequestBodySign(uri, "GET", null, headerMap);
        CloseableHttpClient httpClient = url.startsWith("https://") ? NetBrowser.createSSLClientDefault() : HttpClients.createDefault();
        CloseableHttpResponse response = httpClient.execute(httpUriRequest);
        HttpEntity entity = response.getEntity();
        String repsContent = EntityUtils.toString(entity);
        ApiSixAccountResponse lar = (ApiSixAccountResponse)Jsons.objcet(repsContent, ApiSixAccountResponse.class);
        if (!lar.success()) {
          this.logger.info("Loaded accounts from apiSix : {}", repsContent);
          throw new BusinessException(null, Strings.join(new Object[] { "获取中航金网账号信息失败: ", lar.getError(), "(", lar.getCode(), ")" }));
        } 
        this.logger.info("Loaded accounts from apiSix : {}", lar);
        IDaasAccountLoadResult alr = lar.getResult();
        List<Map<String, Object>> zhOrgs = alr.getRecords();
        if (zhOrgs == null || zhOrgs.isEmpty())
          break; 
        zhOrgAlls.addAll(zhOrgs);
        strNextStartTime = String.valueOf(alr.getNextStartTime());
        if (alr.getNextPageNum() == null)
          break; 
        strpageNum = Integer.valueOf(strpageNum.intValue() + 1);
      } 
    } catch (HttpHostConnectException e) {
      this.logger.error(Strings.join(new Object[] { "apiSix str interface[", apiUrl, "] not accessable : " }, ), e);
      throw new BusinessException(null, "获取组织信息apiSix接口不可访问");
    } catch (IOException|java.net.URISyntaxException e) {
      throw new RuntimeException(Strings.join(new Object[] { "Load zhjw str failed: " }, ), e);
    } 
    cache("zhOrgAlls", zhOrgAlls);
    List<Map<String, Object>> zhOrgStrAlls = new ArrayList<>();
    for (int i = 0; i < zhOrgAlls.size(); i++) {
      Map<String, Object> zhorg = zhOrgAlls.get(i);
      if (zhorg.get("orgType") != null && 
        zhorg.get("orgType").toString().equals("1"))
        zhOrgStrAlls.add(zhorg); 
    } 
    cache("zhOrgStrAlls", zhOrgStrAlls);
    Map<String, Map<String, Object>> orgEnterpriseNoMap = CollectionHelper.mapDict(zhOrgStrAlls, zho -> zho.get("companyId").toString());
    this.logger.info("apiSix str org {}", orgEnterpriseNoMap);
    List<BasicDBObject> baseObjects = this.basicMongoDBService.findFastByTenantIdAndSubCode(tenantId, "B01");
    Map<String, BasicDBObject> basicDBObjectMap = CollectionHelper.mapDict(baseObjects, base -> base.getString("B01U1"));
    List<StructurePOJO> structurePOJOS = this.structureService.findAllStructure(tenantId);
    Map<String, StructurePOJO> uuidstructurePOJOMap = CollectionHelper.mapDict(structurePOJOS, str -> str.getOrgId());
    List<Map<String, Object>> zhUsersAll = new ArrayList<>();
    try {
      while (true) {
        URI uri = (new URIBuilder(url)).addParameter("startTime", startTime).addParameter("includeStartTime", "true").addParameter("pageNum", String.valueOf(pageNum)).build();
        HttpUriRequest httpUriRequest = signatureAuth.createHttpUriRequestBodySign(uri, "GET", null, headerMap);
        CloseableHttpClient httpClient = url.startsWith("https://") ? NetBrowser.createSSLClientDefault() : HttpClients.createDefault();
        CloseableHttpResponse response = httpClient.execute(httpUriRequest);
        HttpEntity entity = response.getEntity();
        String repsContent = EntityUtils.toString(entity);
        ApiSixAccountResponse lar = (ApiSixAccountResponse)Jsons.objcet(repsContent, ApiSixAccountResponse.class);
        if (!lar.success()) {
          this.logger.info("Loaded accounts from apiSix : {}", repsContent);
          throw new BusinessException(null, Strings.join(new Object[] { "获取中航金网账号信息失败: ", lar.getError(), "(", lar.getCode(), ")" }));
        } 
        this.logger.info("Loaded accounts from apiSix : {}", lar);
        IDaasAccountLoadResult alr = lar.getResult();
        List<Map<String, Object>> zhUsers = alr.getRecords();
        if (zhUsers == null || zhUsers.isEmpty())
          break; 
        for (Map<String, Object> zu : zhUsers) {
          zu.remove("image");
          this.logger.info("Loaded apisix user: {}", zu);
        } 
        zhUsersAll.addAll(zhUsers);
        saveOrUpdateUsers(tenantId, zhUsers, zhId_hjuser, stc, rds, "", orgEnterpriseNoMap, basicDBObjectMap, uuidstructurePOJOMap, true);
        nextStartTime = String.valueOf(alr.getNextStartTime());
        if (alr.getNextPageNum() == null)
          break; 
        pageNum = Integer.valueOf(pageNum.intValue() + 1);
      } 
    } catch (HttpHostConnectException e) {
      this.logger.error(Strings.join(new Object[] { "apiSix interface[", apiUrl, "] not accessable : " }, ), e);
      throw new BusinessException(null, "获取账号信息apiSix接口不可访问");
    } catch (IOException|java.net.URISyntaxException e) {
      throw new RuntimeException(Strings.join(new Object[] { "Load zhjw accounts failed: " }, ), e);
    } 
    cache("zhUserAlls", zhUsersAll);
    this.logger.info("Sync zhjw apisix accounts report: {}", stc);
    return nextStartTime;
  }
  
  private void saveOrUpdateUsers(String tenantId, List<Map<String, Object>> orgZhUsers, Map<String, UserEntity> zhId_hjuser, SyncStastics stc, List<RecordDetailEntity> rds, String suffix, Map<String, Map<String, Object>> orgEnterpriseNoMap, Map<String, BasicDBObject> basicDBObjectMap, Map<String, StructurePOJO> uuidStructurePOJOMap, boolean isjh) {
    this.logger.info("basicDBObjectMap {}", basicDBObjectMap);
    stc.loadCount += orgZhUsers.size();
    List<Map<String, Object>> zhUsers = CollectionHelper.mergeRepeat(orgZhUsers, (a, b) -> Objects.equals(a.get("userId"), b.get("userId")), res -> (Map)res.get(res.size() - 1));
    stc.repeatMergeCount += orgZhUsers.size() - zhUsers.size();
    List<UserEntity> allHjUser = this.rpcUserService.findByTenantId(tenantId);
    Map<String, UserEntity> allHjUserMap = CollectionHelper.mapDict(allHjUser, all -> all.getLoginName());
    List<UserEntity> existedHjUsers = new ArrayList<>(zhUsers.size());
    List<String> thirdIds = CollectionHelper.extractToList(zhUsers, zu -> (String)zu.get("userId"));
    CollectionHelper.extractTo(thirdIds, tid -> (UserEntity)paramMap.get(tid), existedHjUsers);
    thirdIds.removeIf(i -> paramMap.containsKey(i));
    if (!thirdIds.isEmpty()) {
      Set<String> idTemp = new HashSet<>();
      BatchUtils.excuteBatch(300, thirdIds, batch -> {
            paramSet.clear();
            paramSet.addAll(batch);
            List<UserEntity> hjUsers = this.rpcUserService.findUuidAndStatusByThirdIds(paramString, paramSet);
            paramList1.addAll(hjUsers);
          });
      CollectionHelper.mapDictTo(existedHjUsers, u -> u.getThirdId(), zhId_hjuser);
    } 
    Map<String, RecordDetailEntity> thirdId_record = new HashMap<>();
    try {
      if (!existedHjUsers.isEmpty()) {
        Map<String, UserEntity> zhid_ehjUser = CollectionHelper.mapDict(existedHjUsers, ezu -> ezu.getThirdId());
        List<UserEntity> updateUsers = new ArrayList<>();
        List<Map<String, Object>> existZhUsers = CollectionHelper.removeAll(zhUsers, zu -> paramMap1.containsKey(zu.get("userId")));
        Date now = new Date();
        for (Map<String, Object> zu : existZhUsers) {
          UserEntity hjUser = zhid_ehjUser.get(zu.get("userId"));
          boolean changed = checkUserChangeAndSet(zu, hjUser, thirdId_record, suffix, allHjUserMap, orgEnterpriseNoMap, basicDBObjectMap, uuidStructurePOJOMap, isjh);
          if (!changed) {
            stc.notUpdateCount++;
            continue;
          } 
          hjUser.setModifyTs(now);
          updateUsers.add(hjUser);
        } 
        if (!updateUsers.isEmpty()) {
          stc.updateCount += updateUsers.size();
          updatesUsers(updateUsers);
          thirdId_record.values().forEach(r -> r.setFlag(Boolean.valueOf(true)));
        } 
      } 
      if (zhUsers.isEmpty())
        return; 
      List<Map<String, Object>> unavailiables = CollectionHelper.removeAll(zhUsers, u -> !(((Integer)u.get("status")).intValue() >= 2000 && ((Integer)u.get("syncStatus")).intValue() == 2000));
      if (!unavailiables.isEmpty()) {
        stc.notCreateCount += unavailiables.size();
        this.logger.warn("Not availiable zhjw users: {}", unavailiables);
        if (zhUsers.isEmpty())
          return; 
      } 
      stc.newCount += zhUsers.size();
      List<UserEntity> hjUsersContainer = mapToHjUsers(zhUsers, thirdId_record, suffix, allHjUserMap, orgEnterpriseNoMap, basicDBObjectMap, uuidStructurePOJOMap, isjh);
      List<UserEntity> adminUser = this.userService.findByTenantIdAndAccountType(tenantId, "t_sys_admin");
      UserEntity user = new UserEntity();
      if (adminUser.size() == 0) {
        user = this.userService.findUserAdminByTenantId(tenantId);
      } else {
        user = adminUser.get(0);
      } 
      UserEntity finalUser = user;
      BatchUtils.excuteBatch(100, hjUsersContainer, batch -> {
            this.logger.info("save new zhUsers zhids[{}]", CollectionHelper.extractToSet(batch, ()));
            List<UserEntity> savedUsers = this.rpcUserService.createsNoStaffAccountForJc(batch, paramString1, paramString2);
            CollectionHelper.mapDictTo(savedUsers, (), paramMap1);
            for (UserEntity u : savedUsers) {
              this.logService.log(paramString1, paramUserEntity, "600902", "新增用户：【" + u.getUserName() + "】人员编号为：【U" + u.getLoginName() + "】", null);
              RecordDetailEntity rd = (RecordDetailEntity)paramMap2.get(u.getThirdId());
              rd.setFlag(Boolean.valueOf(true));
            } 
          });
    } finally {
      rds.addAll(thirdId_record.values());
    } 
  }
  
  private List<Map<String, Object>> csbToZhUsers(List<Map<String, Object>> csbUsers) {
    List<Map<String, Object>> zhUsers = new ArrayList<>(csbUsers.size());
    for (Map<String, Object> csbUser : csbUsers) {
      Map<String, Object> zu = new HashMap<>();
      zu.put("userId", csbUser.get("USER_ID"));
      zu.put("displayName", csbUser.get("USER_NAME"));
      zu.put("workNo", csbUser.get("USER_CODE"));
      zu.put("country", csbUser.get("COUNTRY"));
      zu.put("sex", (csbUser.get("SEX") == null) ? null : csbUser.get("SEX").toString());
      zu.put("mobile", csbUser.get("MOBILE"));
      zu.put("swEmail", csbUser.get("EAMIL"));
      zu.put("status", csbUser.get("STATUS"));
      zu.put("syncStatus", csbUser.get("GLOBAL_STATUS"));
      zu.put("companyId", csbUser.get("COMPANY_ID"));
      zu.put("COMPANY", csbUser.get("COMPANY"));
      zu.put("_orgData", csbUser);
      zhUsers.add(zu);
    } 
    this.logger.info("csb user transfered to zhusers : {}", zhUsers);
    return zhUsers;
  }
  
  private List<Map<String, Object>> csbToZhStrs(List<Map<String, Object>> csbStrs) {
    List<Map<String, Object>> zhSTrs = new ArrayList<>(csbStrs.size());
    for (Map<String, Object> csbUser : csbStrs) {
      Map<String, Object> zu = new HashMap<>();
      zu.put("COMPANY_ID", csbUser.get("COMPANY_ID"));
      zu.put("ORG_NO", csbUser.get("ORG_NO"));
      zhSTrs.add(zu);
    } 
    this.logger.info("csb user transfered to zhSTrs : {}", zhSTrs);
    return zhSTrs;
  }
  
  private List<UserEntity> mapToHjUsers(List<Map<String, Object>> zhUsers, Map<String, RecordDetailEntity> thirdId_record, String suffix, Map<String, UserEntity> allHjUserMap, Map<String, Map<String, Object>> orgEnterpriseNoMap, Map<String, BasicDBObject> basicDBObjectMap, Map<String, StructurePOJO> uuidStructurePOJOMap, boolean isjh) {
    List<UserEntity> hjUsers = new ArrayList<>(zhUsers.size());
    for (Map<String, Object> zhUser : zhUsers) {
      String secretLevel = (String)zhUser.get("secretLevel");
      Integer hjySecretLevel = Integer.valueOf(StringUtils.isBlank(secretLevel) ? 4 : ((Integer)this.zhsl_hjsl.get(secretLevel)).intValue());
      String workNo = (String)zhUser.get("workNo");
      String name = (String)zhUser.get("displayName");
      String email = (String)zhUser.get("swEmail");
      String zhUserId = (String)zhUser.get("userId");
      RecordDetailEntity rd = createNewRecordDetail(zhUser, workNo, name);
      if (hjySecretLevel == null) {
        rd.setErrmsg(Strings.join(new Object[] { "密级对应失败：未找到IDaas密级(", secretLevel, ")在干部系统中对应的值" }));
        continue;
      } 
      Integer zhStatus = (Integer)zhUser.get("status");
      String loginPhone = (String)zhUser.get("mobile");
      UserEntity user = new UserEntity();
      user.setUserName(name);
      if (isjh) {
        String enterpriseNo = "";
        List<Map<String, Object>> companyList = (List<Map<String, Object>>)zhUser.get("userJobInfo");
        if (companyList != null) {
          for (Map<String, Object> company : companyList) {
            if (!Strings.equals((company.get("userJobType") == null) ? "" : company.get("userJobType").toString(), "0"))
              continue; 
            if (orgEnterpriseNoMap.get(company.get("companyId")) == null) {
              enterpriseNo = "";
              continue;
            } 
            if (((Map)orgEnterpriseNoMap.get(company.get("companyId"))).get("enterpriseNo") == null) {
              enterpriseNo = "";
              rd.setErrmsg("第三方组织未找到" + company.get("companyId") + "对应的enterpriseNo");
              break;
            } 
            enterpriseNo = ((Map)orgEnterpriseNoMap.get(company.get("companyId"))).get("enterpriseNo").toString();
            break;
          } 
          if (StringUtils.isNotBlank(enterpriseNo)) {
            BasicDBObject basicDBObject = basicDBObjectMap.get(enterpriseNo);
            if (basicDBObject != null) {
              StructurePOJO structurePOJO = uuidStructurePOJOMap.get(basicDBObject.getString("orgId"));
              if (structurePOJO != null) {
                if (!Strings.equals(user.getAccountUnitId(), structurePOJO.getOrgId()) && 
                  structurePOJO.getOrgType().intValue() == 1) {
                  user.setAccountUnitId(structurePOJO.getOrgId());
                  user.setAccountUnitCode(structurePOJO.getOrgCode());
                  user.setAccountUnitName(structurePOJO.getOrgName());
                } 
              } else {
                rd.setErrmsg("云中未找到" + name + "对应的组织");
              } 
            } else {
              rd.setErrmsg("云中未找到" + name + "对应的组织");
            } 
          } else {
            rd.setErrmsg("未找到第三方" + name + "对应的组织");
          } 
        } else {
          rd.setErrmsg("未找到company" + name + "对应的第三方组织");
        } 
      } else {
        String enterpriseNo = "";
        List<Map<String, Object>> companyList = (List<Map<String, Object>>)zhUser.get("COMPANY");
        if (companyList != null) {
          String companyId = "";
          for (Map<String, Object> company : companyList) {
            if (company.get("VIRTUAL_USER_TYPE") != null && 
              !Strings.equals(company.get("VIRTUAL_USER_TYPE").toString(), "10"))
              continue; 
            String hkCompayId = (String)company.get("COMPANY_ID");
            if (orgEnterpriseNoMap.get(hkCompayId) == null) {
              enterpriseNo = "";
              continue;
            } 
            if (((Map)orgEnterpriseNoMap.get(hkCompayId)).get("ORG_NO") == null) {
              enterpriseNo = "";
              rd.setErrmsg("第三方组织未找到" + hkCompayId + "对应的ORG_NO");
              break;
            } 
            companyId = hkCompayId.toString();
            enterpriseNo = ((Map)orgEnterpriseNoMap.get(hkCompayId)).get("ORG_NO").toString();
          } 
          BasicDBObject basicDBObject = null;
          if (StringUtils.isNotBlank(enterpriseNo)) {
            basicDBObject = basicDBObjectMap.get(enterpriseNo);
          } else if (StringUtils.isNotBlank(companyId)) {
            basicDBObject = basicDBObjectMap.get(companyId);
          } else {
            rd.setErrmsg("未找到第三方enterpriseNo" + enterpriseNo + "对应的组织");
            continue;
          } 
          if (basicDBObject != null) {
            StructurePOJO structurePOJO = uuidStructurePOJOMap.get(basicDBObject.getString("orgId"));
            if (structurePOJO != null) {
              if (!Strings.equals(user.getAccountUnitId(), structurePOJO.getOrgId()) && 
                structurePOJO.getOrgType().intValue() == 1) {
                user.setAccountUnitId(structurePOJO.getOrgId());
                user.setAccountUnitCode(structurePOJO.getOrgCode());
                user.setAccountUnitName(structurePOJO.getOrgName());
              } 
            } else {
              rd.setErrmsg("云中未找到enterpriseNo" + enterpriseNo + "对应的组织");
              continue;
            } 
          } else {
            rd.setErrmsg("云中未找到enterpriseNo" + enterpriseNo + "对应的组织");
            continue;
          } 
        } else {
          rd.setErrmsg("未找到company" + enterpriseNo + "对应的第三方组织");
          continue;
        } 
      } 
      thirdId_record.put(zhUserId, rd);
      if (StringUtils.isBlank(workNo)) {
        user.setLoginName(workNo);
      } else {
        if ("".equals(suffix)) {
          user.setLoginName(workNo);
        } else {
          user.setLoginName(String.valueOf(workNo) + "_" + suffix);
        } 
        if (allHjUserMap.get(user.getLoginName()) != null) {
          Map<String, UserEntity> filteredMap = (Map<String, UserEntity>)allHjUserMap.entrySet().stream()
            .filter(entry -> ((String)entry.getKey()).startsWith(paramUserEntity.getLoginName()))
            .collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue));
          int maxNumber = ((Integer)filteredMap.keySet().stream()
            .map(key -> Integer.valueOf(Integer.parseInt(key.substring(key.lastIndexOf("_") + 1))))
            .max(Integer::compare)
            .orElse(Integer.valueOf(0))).intValue() + 1;
          workNo = String.valueOf(user.getLoginName()) + "_" + maxNumber;
          user.setLoginName(workNo);
        } 
      } 
      user.setEmail(email);
      user.setThirdId(zhUserId);
      user.setLoginPhone(loginPhone);
      user.setSubAccountType(Integer.valueOf(1));
      user.setStatus(Integer.valueOf((zhStatus == null || (zhStatus.intValue() >= 2000 && zhStatus.intValue() != 3000)) ? 1 : 0));
      user.setSecretVal(hjySecretLevel);
      hjUsers.add(user);
    } 
    return hjUsers;
  }
  
  public static void main(String[] args) {
    String map = " {\"USER_ID\":\"022579ae6b714cff933c94de5892ac3f\",\"MOBILE\":\"13581519302\",\"EMAIL\":\"zhouc@avicnet.cn\",\"GLOBAL_STATUS\":2000,\"USER_TYPE\":\"10\",\"USER_CODE\":\"736968\",\"USER_NAME\":\"周超\",\"COUNTRY\":\"中国大陆\",\"SEX\":1,\"NATIONALITY\":\"汉族\",\"EMAIL_STATUS\":20,\"USER_NAME_PINYIN_FIRST_LETTER\":\"zc\",\"USER_NAME_PINYIN\":\"zhouchao\",\"AUTH_FLAG\":\"10\",\"USER_NO\":\"15903388\",\"IS_ACTIVE\":1,\"PHOTO\":\"https://sw-ctest-im.oss-cn-beijing.aliyuncs.com/b12e6cdc7853480ca638e5aaf95747cc.jpg?wh=1000\",\"STATUS\":2000,\"UPDATE_TIME\":1677049270000,\"ADD_TIME\":1572855626000,\"ACCOUNT_TYPE\":\"10\",\"COMPANY\":[{\"COMPANY_ID\":\"0ecc9c9c665d4fcbaf22e1a0b10e672a\",\"VIRTUAL_USER_TYPE\":10,\"ORG_JOB_DUTY\":\"40c71ab793fb482897eafa27682ea5e0\",\"USER_POST\":\"f786908c3a7c4ab0af4db4b6a6d68ba4\",\"ORGS\":[{\"ORG_USER_ID\":\"1fb599dd4bf24986b292a64f08e3cf0a\",\"ORG_ID\":\"00e615cd058a4d36b16c506219cb5317\",\"SHOW_ORDER\":1,\"IS_MAIN_JOB_ORG\":1}]}],\"LAST_SYN_TIME\":1683772076000,\"TENANT_ID\":1}";
    ObjectMapper objectMapper = new ObjectMapper();
    try {
      Map zhUser = objectMapper.<Map>readValue(map, Map.class);
      List<Map<String, Object>> companyList = (List<Map<String, Object>>)zhUser.get("COMPANY");
      String enterpriseNo = "";
      if (companyList != null)
        for (Map<String, Object> company : companyList) {
          if (Strings.equals(company.get("VIRTUAL_USER_TYPE").toString(), "10"))
            break; 
        }  
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  private boolean checkUserChangeAndSet(Map<String, Object> zhUser, UserEntity hjUser, Map<String, RecordDetailEntity> thirdId_record, String suffix, Map<String, UserEntity> allHjUserMap, Map<String, Map<String, Object>> orgEnterpriseNoMap, Map<String, BasicDBObject> basicDBObjectMap, Map<String, StructurePOJO> uuidStructurePOJOMap, boolean isjh) {
    boolean changed = false;
    Integer authStatus = (Integer)zhUser.get("syncStatus");
    boolean canceledAuth = (authStatus != null && authStatus.intValue() != 2000);
    String name = (String)zhUser.get("displayName");
    String changeDesc = null;
    if (canceledAuth) {
      if (hjUser.getStatus().intValue() == 0)
        return false; 
      hjUser.setStatus(Integer.valueOf(0));
      changed = true;
      changeDesc = "取消该账号对干部系统的授权，禁用账号";
    } else {
      List<String> descs = new ArrayList<>();
      if (isjh) {
        String enterpriseNo = "";
        List<Map<String, Object>> companyList = (List<Map<String, Object>>)zhUser.get("userJobInfo");
        if (companyList != null) {
          for (Map<String, Object> company : companyList) {
            if (!Strings.equals((company.get("userJobType") == null) ? "" : company.get("userJobType").toString(), "0"))
              continue; 
            if (orgEnterpriseNoMap.get(company.get("companyId")) == null) {
              enterpriseNo = "";
              continue;
            } 
            if (((Map)orgEnterpriseNoMap.get(company.get("companyId"))).get("enterpriseNo") == null) {
              enterpriseNo = "";
              descs.add("第三方组织未找到" + company.get("companyId") + "对应的enterpriseNo");
              break;
            } 
            enterpriseNo = ((Map)orgEnterpriseNoMap.get(company.get("companyId"))).get("enterpriseNo").toString();
            break;
          } 
          if (StringUtils.isNotBlank(enterpriseNo)) {
            BasicDBObject basicDBObject = basicDBObjectMap.get(enterpriseNo);
            if (basicDBObject != null) {
              StructurePOJO structurePOJO = uuidStructurePOJOMap.get(basicDBObject.getString("orgId"));
              if (structurePOJO != null) {
                if (!Strings.equals(hjUser.getAccountUnitId(), structurePOJO.getOrgId())) {
                  changed = true;
                  if (structurePOJO.getOrgType().intValue() == 1) {
                    hjUser.setAccountUnitId(structurePOJO.getOrgId());
                    hjUser.setAccountUnitCode(structurePOJO.getOrgCode());
                    hjUser.setAccountUnitName(structurePOJO.getOrgName());
                  } 
                } 
              } else {
                changed = true;
                descs.add("云中未找到" + enterpriseNo + "对应的组织");
              } 
            } else {
              changed = true;
              descs.add("云中未找到" + enterpriseNo + "对应的组织");
            } 
          } else {
            changed = true;
            descs.add("未找到第三方" + name + "对应的组织");
          } 
        } else {
          changed = true;
          descs.add("未找到COMPANYID" + name);
        } 
      } else {
        String enterpriseNo = "";
        List<Map<String, Object>> companyList = (List<Map<String, Object>>)zhUser.get("COMPANY");
        if (companyList != null) {
          for (Map<String, Object> company : companyList) {
            if (company.get("VIRTUAL_USER_TYPE") == null || Strings.equals((company.get("VIRTUAL_USER_TYPE") == null) ? "" : company.get("VIRTUAL_USER_TYPE").toString(), "10")) {
              if (orgEnterpriseNoMap.get(company.get("COMPANY_ID")) == null) {
                enterpriseNo = "";
              } else {
                if (((Map)orgEnterpriseNoMap.get(company.get("COMPANY_ID"))).get("ORG_NO") == null) {
                  enterpriseNo = "";
                  descs.add("第三方组织未找到" + company.get("COMPANY_ID") + "对应的eORG_NO");
                  break;
                } 
                enterpriseNo = ((Map)orgEnterpriseNoMap.get(company.get("COMPANY_ID"))).get("ORG_NO").toString();
              } 
              this.logger.info("enterpriseNo userName{},No {}", hjUser.getUserName(), enterpriseNo);
              if (StringUtils.isNotBlank(enterpriseNo)) {
                BasicDBObject basicDBObject = basicDBObjectMap.get(enterpriseNo);
                this.logger.info("enterpriseNo userName{},basicDBObject {}", hjUser.getUserName(), basicDBObject);
                if (basicDBObject != null) {
                  StructurePOJO structurePOJO = uuidStructurePOJOMap.get(basicDBObject.getString("orgId"));
                  this.logger.info("enterpriseNo userName{},structurePOJO {}", hjUser.getUserName(), structurePOJO);
                  if (structurePOJO != null) {
                    if (!Strings.equals(hjUser.getAccountUnitId(), structurePOJO.getOrgId())) {
                      changed = true;
                      if (structurePOJO.getOrgType().intValue() == 1) {
                        hjUser.setAccountUnitId(structurePOJO.getOrgId());
                        hjUser.setAccountUnitCode(structurePOJO.getOrgCode());
                        hjUser.setAccountUnitName(structurePOJO.getOrgName());
                      } 
                    } 
                    break;
                  } 
                  changed = true;
                  descs.add("云中未找到" + enterpriseNo + "对应的组织");
                  break;
                } 
                changed = true;
                descs.add("云中未找到str" + enterpriseNo + "对应的组织");
                break;
              } 
              changed = true;
              descs.add("未找到第三方" + enterpriseNo + "对应的组织");
              break;
            } 
          } 
        } else {
          changed = true;
          descs.add("未找到COMPANY" + enterpriseNo);
        } 
      } 
      Integer zhStatus = (Integer)zhUser.get("status");
      int newHjStatus = (zhStatus == null || (zhStatus.intValue() >= 2000 && zhStatus.intValue() != 3000)) ? 1 : 0;
      if (newHjStatus != hjUser.getStatus().intValue()) {
        hjUser.setStatus(Integer.valueOf(newHjStatus));
        descs.add((newHjStatus == 1) ? "启用账号(重新授权给干部系统或重新启用)" : ((zhStatus.intValue() == 3000) ? "禁用账号(IDaas已停用该账号)" : ((zhStatus.intValue() == -1000) ? "禁用账号(IDaas已注销该账号)" : "禁用账号(该账号在IDaas中已失效)")));
        changed = true;
      } 
      if (StringUtils.isNotBlank(name) && !StringUtils.equals(name, hjUser.getUserName())) {
        descs.add(Strings.join(new Object[] { "姓名(", hjUser.getUserName(), " -> ", name, ")" }));
        hjUser.setUserName(name);
        changed = true;
      } 
      String workNo = (String)zhUser.get("workNo");
      if (StringUtils.isNotBlank(workNo) && !hjUser.getLoginName().startsWith(workNo)) {
        descs.add(Strings.join(new Object[] { "编码(", hjUser.getLoginName(), " -> ", workNo, ")" }));
        if ("".equals(suffix)) {
          hjUser.setLoginName(workNo);
        } else {
          hjUser.setLoginName(String.valueOf(workNo) + "_" + suffix);
        } 
        if (allHjUserMap.get(hjUser.getLoginName()) != null) {
          Map<String, UserEntity> filteredMap = (Map<String, UserEntity>)allHjUserMap.entrySet().stream()
            .filter(entry -> ((String)entry.getKey()).startsWith(paramUserEntity.getLoginName()))
            .collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue));
          int maxNumber = ((Integer)filteredMap.keySet().stream()
            .map(key -> Integer.valueOf(Integer.parseInt(key.substring(key.lastIndexOf("_") + 1))))
            .max(Integer::compare)
            .orElse(Integer.valueOf(0))).intValue() + 1;
          workNo = String.valueOf(hjUser.getLoginName()) + "_" + maxNumber;
          hjUser.setLoginName(workNo);
        } 
        changed = true;
      } 
      String email = (String)zhUser.get("swEmail");
      email = StringUtils.isNotBlank(email) ? email.replaceAll(" ", "") : email;
      if (!StringUtils.equals(email, hjUser.getEmail())) {
        descs.add(Strings.join(new Object[] { "邮箱(", hjUser.getEmail(), " -> ", email, ")" }));
        hjUser.setEmail(email);
        changed = true;
      } 
      String mobile = (String)zhUser.get("mobile");
      mobile = StringUtils.isNotBlank(mobile) ? mobile.replaceAll(" ", "") : mobile;
      if (!StringUtils.equals(mobile, hjUser.getLoginPhone())) {
        descs.add(Strings.join(new Object[] { "手机(", hjUser.getLoginPhone(), " -> ", mobile, ")" }));
        hjUser.setLoginPhone(mobile);
        changed = true;
      } 
      String secretLevel = (String)zhUser.get("secretLevel");
      Integer newHjySecretLevel = Integer.valueOf(StringUtils.isBlank(secretLevel) ? 4 : ((Integer)this.zhsl_hjsl.get(secretLevel)).intValue());
      if (newHjySecretLevel == null) {
        descs.add(Strings.join(new Object[] { "密级更新失败：未找到IDaas密级(", secretLevel, ")在干部系统中对应的值" }));
        changed = true;
      } else {
        Integer oldHjySecretLevel = hjUser.getSecretVal();
        oldHjySecretLevel = Integer.valueOf((oldHjySecretLevel == null || oldHjySecretLevel.intValue() == 0) ? 4 : oldHjySecretLevel.intValue());
        if (newHjySecretLevel.intValue() != oldHjySecretLevel.intValue()) {
          this.logger.info("sout secret newHjySecretLevel{},oldHjySecretLevel{}", newHjySecretLevel, oldHjySecretLevel);
          descs.add(Strings.join(new Object[] { 
                  "密级(", this.hjsl_name.get(oldHjySecretLevel), "[", oldHjySecretLevel, "] -> ", this.hjsl_name.get(newHjySecretLevel), "[云：", newHjySecretLevel, "，IDaas：", secretLevel, 
                  "])" }));
          hjUser.setSecretVal(newHjySecretLevel);
          changed = true;
        } 
      } 
      changeDesc = Strings.joinCollectionWith(";", descs);
    } 
    if (changed) {
      RecordDetailEntity rd = createUpdateRecordDetail(zhUser, hjUser.getLoginName(), changeDesc, name);
      thirdId_record.put(hjUser.getThirdId(), rd);
    } 
    return changed;
  }
  
  private RecordDetailEntity createUpdateRecordDetail(Map<String, Object> zhUser, String thirdId, String changeDesc, String name) {
    RecordDetailEntity rd = new RecordDetailEntity();
    changeDesc = (changeDesc == null) ? "账号信息更新" : changeDesc;
    rd.setErrmsg(changeDesc);
    rd.setFlag(Boolean.valueOf(false));
    rd.setThirdId(thirdId);
    rd.setName(name);
    rd.setOperation(RecordDetailEntity.OPERATION_UPDATE);
    rd.setDataType("4");
    rd.setType("1");
    Object orgData = zhUser.get("_orgData");
    orgData = (orgData == null) ? zhUser : orgData;
    rd.setData(Jsons.jsonString(orgData));
    return rd;
  }
  
  private RecordDetailEntity createNewRecordDetail(Map<String, Object> zhUser, String thirdId, String name) {
    RecordDetailEntity rd = new RecordDetailEntity();
    rd.setErrmsg("新增账号");
    rd.setFlag(Boolean.valueOf(false));
    rd.setThirdId(thirdId);
    rd.setName(name);
    rd.setOperation(RecordDetailEntity.OPERATION_ADD);
    rd.setDataType("4");
    rd.setType("1");
    Object orgData = zhUser.get("_orgData");
    orgData = (orgData == null) ? zhUser : orgData;
    rd.setData(Jsons.jsonString(orgData));
    return rd;
  }
  
  private void updatesUsers(List<UserEntity> updateUsers) {
    this.rpcUserService.updates(updateUsers, CollectionHelper.newArrayList((Object[])new String[] { "userName", "loginName", "email", "loginPhone", "status", "secretVal", "accountUnitId", "accountUnitName", "accountUnitCode" }, ), CollectionHelper.newArrayList((Object[])new String[] { "uuid" }));
  }
  
  private IDaasValidTicketResponse getUserInfoFromTicketByApiSix(String apiUrl, String idaasAppId, String idaasAccessKey, String idaasSecretKey, String ticket, String redirectUrl, String selfDomain) {
    try {
      SignatureAuthConfig signatureAuthConfig = new SignatureAuthConfig();
      signatureAuthConfig.setApiGw(ApiGwEnum.APACHE_APISIX);
      signatureAuthConfig.setAccessKey(idaasAccessKey);
      signatureAuthConfig.setSecretKey(idaasSecretKey);
      SignatureAuth signatureAuth = SignatureAuthFactory.createSignatureAuth(signatureAuthConfig);
      URI uri = (new URIBuilder(String.valueOf(apiUrl) + "/idaas/auth/cas/" + idaasAppId + "/p3/serviceValidate"))
        .addParameter("service", redirectUrl).addParameter("format", "json").addParameter("ticket", ticket).build();
      Map<String, String> headerMap = new HashMap<>();
      headerMap.put("X-Hostname", selfDomain);
      HttpUriRequest httpUriRequest = signatureAuth.createHttpUriRequestBodySign(uri, "GET", null, headerMap);
      CloseableHttpClient httpClient = HttpClients.createDefault();
      CloseableHttpResponse response = httpClient.execute(httpUriRequest);
      String result = EntityUtils.toString(response.getEntity());
      this.logger.info("Load sso user info from apisix : [{}]", result);
      IDaasValidTicketResponse resp = (IDaasValidTicketResponse)Jsons.objcet(result, IDaasValidTicketResponse.class);
      if (!resp.isScuess())
        throw new BusinessException(null, Strings.join(new Object[] { "获取单点用户失败：", resp.getFailInfo().getDescription(), "(", resp.getFailInfo().getCode(), ")" })); 
      return resp;
    } catch (Exception e) {
      throw new RuntimeException(Strings.join(new Object[] { "Valid ticket#", ticket, " by apiSix failed: " }, ), e);
    } 
  }
  
  private IDaasValidTicketResponse getUserInfoFromTicketByCSB(String apiUrl, String idaasAccessKey, String idaasSecretKey, String ticket, String redirectUrl, String selfDomain) {
    HttpParameters.Builder builder = HttpParameters.newBuilder();
    String csbUrl = apiUrl;
    builder.requestURL(csbUrl).api("verifyTicket").version("1.0.0").method("get").contentType("application/json;charset=utf-8");
    builder.putParamsMap("service", new String[] { redirectUrl });
    builder.putParamsMap("format", new String[] { "json" });
    builder.putParamsMap("ticket", new String[] { ticket });
    try {
      HttpReturn ret = HttpCaller.invokeReturn(builder.build());
      String result = ret.getResponseStr();
      this.logger.info("Load sso user info from csb : [{}]", result);
      IDaasValidTicketResponse resp = (IDaasValidTicketResponse)Jsons.objcet(result, IDaasValidTicketResponse.class);
      if (!resp.isScuess())
        throw new BusinessException(null, Strings.join(new Object[] { "获取单点用户失败：", resp.getFailInfo().getDescription(), "(", resp.getFailInfo().getCode(), ")" })); 
      return resp;
    } catch (HttpCallerException e) {
      throw new RuntimeException(e);
    } 
  }
  
  public List<UserTaskEntity> sendUseTasks(List<UserTaskEntity> tasks, IntegrationEntity integration, TenantEntity targetTenant) {
    return null;
  }
  
  public List<UserTaskEntity> sendUseTaskDealeds(List<UserTaskEntity> tasks, IntegrationEntity integration, TenantEntity targetTenant) {
    return null;
  }
  
  public void processCustomParamsBeforeSave(IntegrationCustomEntity newIntegrationCustom, IntegrationCustomEntity oldIntegrationCustom) {
    Map<String, String> configs = newIntegrationCustom.getConfObj();
    String idaasUrl = configs.get("idaasUrl");
    if (StringUtils.isNotBlank(idaasUrl)) {
      idaasUrl = idaasUrl.endsWith("/") ? idaasUrl : (String.valueOf(idaasUrl) + "/");
      configs.put("idaasUrl", idaasUrl);
    } 
    String apiUrl = configs.get("apiUrl");
    if (StringUtils.isNotBlank(apiUrl)) {
      apiUrl = apiUrl.endsWith("/") ? apiUrl : (String.valueOf(apiUrl) + "/");
      configs.put("apiUrl", apiUrl);
    } 
    String archiveUrl = configs.get("archiveUrl");
    if (StringUtils.isNotBlank(apiUrl)) {
      archiveUrl = archiveUrl.endsWith("/") ? archiveUrl : (String.valueOf(archiveUrl) + "/");
      configs.put("archiveUrl", archiveUrl);
    } 
    String hcmUrl = configs.get("hcmUrl");
    if (StringUtils.isNotBlank(hcmUrl)) {
      hcmUrl = hcmUrl.endsWith("/") ? hcmUrl : (String.valueOf(hcmUrl) + "/");
      configs.put("hcmUrl", hcmUrl);
    } 
    newIntegrationCustom.setConfigs(Jsons.jsonString(configs));
  }
  
  public HcmTheme getHcmTheme(String tenantId, String zhjwUserId) {
    IntegrationCustomEntity ic = this.integrationCustomService.getByTenantIdAndAppKey(tenantId, "zhjw");
    Map<String, String> config = ic.getConfObj();
    String hcmDomain = (config == null) ? null : config.get("hcmUrl");
    if (StringUtils.isBlank(hcmDomain)) {
      this.logger.warn("Load theme for user[zhjwId:{}] failed: no hcm domain setted !", zhjwUserId);
      return null;
    } 
    return this.hcmService.getHcmTheme(hcmDomain, zhjwUserId);
  }
}
